<template>
<div v-if="this.$store.getters.authenticatedUser">
    <b-container >
      <b-modal ref="my-modal" hide-footer title="Confirmation message">
      <div class="d-block text-center">
        <h6>Configuration links have been updated!</h6>
      </div>
      <div> <b-row>
        <b-col cols="4"></b-col>
        <b-col cols="4">
          <b-button class="mt-3" variant="success" block @click="hideModal">Ok</b-button>
        </b-col>
      <b-col cols="4"></b-col>
      </b-row>
      </div>
    </b-modal>
       <div style ="min-height : 780px">
       <br>
           <b-col>
               <b-row  align-h="center"  > <h2  style="color : #22b574  " > Configuration </h2>
               </b-row>
               <br>
      <!--         <b-row>
                   <b-col cols = "4">
                   </b-col>
                   <b-col cols = "2" ><h5 style="color : #22b574  "   class="float-left">API URL: </h5>
                   </b-col>
                   <b-col cols = "4">
                     <b-form-group
        label-cols-sm="0"
        label=""
        label-for="nested-name"      >
        <b-form-input id="nested-API_URL" class="rounded" style = " border-radius: 0.7rem "
         v-model = "api_url"
        ></b-form-input>
      </b-form-group>
                   </b-col>
                   <b-col cols = "2">
                   </b-col>
               </b-row>
               <b-row>
                   <b-col cols = "4">
                   </b-col>
                   <b-col cols = "2" > <h5 style="color : #22b574  "  class="float-left">MEMO URL:</h5>
                   </b-col>
                   <b-col cols = "4">
                     <b-form-group
        label-cols-sm="0"
        label=""
        label-for="nested-name"      >
        <b-form-input id="nested-API_URL" class="rounded" style = " border-radius: 0.7rem "
        v-model = "memo_url"
        ></b-form-input>
      </b-form-group>
                   </b-col>
                   <b-col cols = "2">
                   </b-col>
               </b-row> -->
               <b-row>
                   <b-col cols = "4">
                   </b-col>
                   <b-col cols = "2" ><h5 style="color : #22b574  "  class="float-left">SLARC URL: </h5>
                   </b-col>
                   <b-col cols = "4"><b-form-group
        label-cols-sm="0"
        label=""
        label-for="nested-name"      >
        <b-form-input id="nested-API_URL" class="rounded" style = " border-radius: 0.7rem "
        v-model = "slarc_url"
        ></b-form-input>
      </b-form-group>
                   </b-col>
                   <b-col cols = "2">
                   </b-col>
               </b-row>
               <b-row>
                   <b-col cols = "4">
                   </b-col>
                   <b-col cols = "2" ><h5 style="color : #22b574  "  class="float-left">VCG URL: </h5>
                   </b-col>
                   <b-col cols = "4"><b-form-group
        label-cols-sm="0"
        label=""
        label-for="nested-name">
        <b-form-input id="nested-API_URL"  class="rounded" style = " border-radius: 0.7rem "
        v-model = "vcg_url"
        ></b-form-input>
      </b-form-group>
                   </b-col>
                   <b-col cols = "2">
                   </b-col>
               </b-row>
               <b-row>
                   <b-col cols = "4">
                   </b-col>
                   <b-col cols = "2"><h5 style="color : #22b574  "  class="float-left">ITLB URL: </h5>
                   </b-col>
                   <b-col cols = "4">
                     <b-form-group
        label-cols-sm="0"
        label=""
        label-for="nested-name"      >
        <b-form-input id="nested-API_URL" class="rounded" style = " border-radius: 0.7rem "
        v-model = "itlb_url"
        ></b-form-input>
      </b-form-group>
                   </b-col>
                   <b-col cols = "2">
                   </b-col>
               </b-row>
               <b-row>
                   <b-col cols = "4">
                   </b-col>
                   <b-col cols = "2"><h5 style="color : #22b574  "  class="float-left">AAA URL: </h5>
                   </b-col>
                   <b-col cols = "4">
                     <b-form-group
        label-cols-sm="0"
        label=""
        label-for="nested-name" >
        <b-form-input id="nested-API_URL" class="rounded" style = " border-radius: 0.7rem "
        v-model = "aaa_url"
        ></b-form-input>
      </b-form-group>
                   </b-col>
                   <b-col cols = "1">
                     <div id="plusbutton" @click="UpdateConfiguration" @mouseover="PlusmouseOver"  @mouseleave="PlusmouseOut">
                <img v-if="HoverPlus"
                width="90%" src= "../assets/SaveButtonAtHover.png" >
                <img v-if="OutOfPlus"
                width="90%" src= "../assets/SaveButton.png" >
                 </div>
                   </b-col>
                   <b-col></b-col>
               </b-row>
            </b-col>
        </div>
    </b-container>
    </div>
<div v-else>
  <NoAccess></NoAccess>
  </div>
</template>
<script>
import MaaSaxios from '../axios/index'
// import moment from 'moment'
import state from '../store/state'
import NoAccess from '../components/NoAccess.vue'
import {mapGetters} from 'vuex'

export default {
  components: {NoAccess},
  beforeCreate () {
    console.log(this.$store.getters.authenticatedUser)
    if (this.$store.getters.authenticatedUser === false) {
      this.$router.push({name: 'home'})
    }

  },
  data () {
    return {
      FederationDetails: [],
      id: '',
      api_url: '',
      memo_url: '',
      slarc_url: '',
      vcg_url: '',
      itlb_url: '',
      aaa_url: '',
      HoverPlus: false,
      OutOfPlus: true
    }
  },
  computed: {
    ...mapGetters([
      'authenticatedUser'
    ]),
    user () {
      // get the fullname of the logged in user
      if (Object.keys(this.$store.state.user).length > 0) {
        return this.$store.state.user.name
      }
      return ''
    }
  },
  methods: {
    

    UpdateConfiguration () {
      const Object1 = {
            
            api_url: this.api_url,
            memo_url: this.memo_url,
            slarc_url: this.slarc_url,
            vcg_url: this.vcg_url,
            itlb_url: this.itlb_url,
            aaa_url: this.aaa_url
          }
      const Id = this.id
      const DataToBeSent = [Object1, Id]

          this.$store.dispatch('UpdateConfiguration', DataToBeSent)       
        .then(response => {
          this.$refs['my-modal'].show()
          }        
         ) 
    },
    hideModal() {
         this.$router.push({name: 'deployments'})
      },

    PlusmouseOver () {
      this.HoverPlus = true
      this.OutOfPlus = false
    },
    PlusmouseOut () {
      this.HoverPlus = false
      this.OutOfPlus = true
    }
  },
  created: function () {
    // get the deployments
    this.$store.dispatch('getConfiguration', null)
      .then(response => {
        console.log(response)
        this.FederationDetails = response.data.results
        this.id = response.data.results[0].id
        this.api_url = response.data.results[0].api_url
        this.memo_url = response.data.results[0].memo_url
        this.slarc_url = response.data.results[0].slarc_url
        this.vcg_url = response.data.results[0].vcg_url
        this.itlb_url = response.data.results[0].itlb_url
        this.aaa_url = response.data.results[0].aaa_url
      })
  }
}
</script>

<style scoped>

</style>
<style >

#pending  {
     background-color : #f1f22a !important ;
     color : #555555 !important ;
     padding-top : 0.01rem !important;
     padding-bottom : 0.01rem !important ;
     border : 0px;
     cursor: not-allowed !important ;
     pointer-events: none !important;
      }

#active {
     background-color :#22b574 !important ;
     color : white !important ;
     padding-top : 0.01rem !important;
     padding-bottom : 0.01rem !important ;
     cursor: not-allowed !important ;
        pointer-events: none !important;
      }

#inactive {
     background-color : #f26076  !important ;
     color : white !important ;
     padding-top : 0.01rem !important;
     padding-bottom : 0.01rem !important  ;
     cursor: not-allowed !important ;
        pointer-events: none !important;
      }

#deletebutton  {
    text-align : right;
}
#plusbutton  {
    text-align : left;
}
</style>
